<link rel="import" href="../../polymer/polymer-element.html" />
<link rel="import" href="app-mis-datos.html" />
<link rel="import" href="app-datos-acceso.html" />
<link rel="import" href="app-sobre-mi.html" />

<dom-module id="app-perfil">
    <template>
        <link rel="stylesheet" href="css/bulma.min.css" />
        <div class="container">
            <h3 class="title has-text-centered">Mi perfil</h3>
            <nav class="tabs is-medium is-centered">
                <ul>
                    <li>
                        <a href="#mis-datos" id="mis-datos">Mis datos</a>
                    </li>
                    <li>
                        <a href="#datos-acceso" id="datos-acceso">Datos de acceso</a>
                    </li>
                    <li>
                        <a href="#sobre-mi" id="sobre-mi">Sobre mí</a>
                    </li>
                </ul>
            </nav>
            <section>
                <app-mis-datos class="is-hidden"></app-mis-datos>
            </section>
            <section>
                <app-datos-acceso class="is-hidden"></app-datos-acceso>
            </section>
            <section>
                <app-sobre-mi class="is-hidden"></app-sobre-mi>
            </section>
            <footer class="footer">
                <button type="buttom" class="button is-pulled-right" on-click="cerrarSesion">
                    Cerrar sesión
                </button>
            </footer>
        </div>
    </template>

    <script>
        class AppPerfil extends Polymer.Element {
            static get is() {
                return "app-perfil";
            }
            static get properties() {
                return {};
            }
            connectedCallback() {
                super.connectedCallback();
                window.addEventListener("hashchange", this.hashActualizado.bind(this));
            }
            disconnectedCallback() {
                super.disconnectedCallback();
                window.addEventListener("hashchange", this.hashActualizado.bind(this));
            }
            /**
             * Handler para el evento "hashchange".
             * Obtiene el hash de la URL.
             * Si la URL no tenía hash, se considera que la sección original es "mis-datos"
             *
             * @param {Object} e el propio evento.
             * @param {string} e.oldURL url antes de que el evento sucediera.
             * @param {string} e.newURL url después de que el evento sucediera.
             */
            hashActualizado({ oldURL, newURL }) {
                let oldID = "";
                if (oldURL.indexOf("#") < 0) {
                    oldID = "mis-datos";
                } else {
                    oldID = oldURL.slice(oldURL.indexOf("#") + 1);
                }

                const newID = newURL.slice(newURL.indexOf("#") + 1);

                this._seccionCambiada(newID, oldID);
            }
            _seccionCambiada(newID, oldID) {
                const shadowRoot = this.shadowRoot;

                shadowRoot.querySelector(`app-${oldID}`).classList.add("is-hidden");
                shadowRoot.querySelector(`#${oldID}`).parentElement.classList.remove("is-active");

                shadowRoot.querySelector(`app-${newID}`).classList.remove("is-hidden");
                shadowRoot.querySelector(`#${newID}`).parentElement.classList.add("is-active");
            }
            cerrarSesion() {
                window.location.replace(".");
            }
            ready() {
                super.ready();
                if (!window.location.hash) {
                    return (window.location.hash = "#mis-datos");
                }

                const seccion = window.location.hash.slice(1);
                this._seccionCambiada(seccion, "mis-datos");
            }
        }

        window.customElements.define(AppPerfil.is, AppPerfil);
    </script>
</dom-module>
